# Tornevall Networks Network Tools - Not yet another ad blocker

## What is it then?

In short: This is a plugin that has history in the spam-posting protection business.

## Project description

This is a project, basically written for personal use. Not **your** personal use actually, but my personal use. The primary purpos is to make my "web experience" cleaner. To make this extension available in a "global state" (meaning, if I switch browser, the extension should follow with full configurable synchronize). To make this possible, it has to be shared as an open public project.

Example: Someone wants to share a website, game, link or just a racist experience with their friend. I am not interested in that experience. Or maybe, I get upset each time I am forced to see it (Like games and tests). This plugin lies in the background, ready to be my saviour, making sure I don't have to see it.

At this point, the plugin is supposed to choose the best practice of blocking content (based on your needs). Either it can block the content (remove it or replace it with a warning), or it can add a warning flag to the element that the share may contain for example "Fake news". Besides, Facebook allow blocking content to a specific limit. Applications are blockable for example. But when it comes to shares, it's not that easy. In some cases, users are forced to either read the shit, or leave the platform.


## Development status

* Current codebase is located at [bitbucket, in develop/3.0.0](https://bitbucket.tornevall.net/projects/WWW/repos/network-tools/browse?at=refs%2Fheads%2Fdevelop%2F3.0.0).
* The minified major release code [is separated in this project](https://tracker.tornevall.net/projects/NT/summary).
* As most of the scripts are minified, [the full version could be found here](https://bitbucket.tornevall.net/projects/WWW/repos/network-tools-js/browse?at=refs%2Fheads%2Fdevelop%2F3.0.0). For pullrequests, this is the place you want to be.
* If you'd like to join the project as a developer [register and sign in here](https://tracker.tornevall.net/).
* Follow the development in words at [HERE](https://developer.tornevall.net/).
* The project will be a part of [The Giraffe Project](https://developer.tornevall.net/2019/11/11/the-giraffe-project/).

### What this project does not support

* Unfortunately, mobile phones is excluded (for Chrome). Chrome for mobiles does not support extensions at all. As I know it, there are no plans for such support either. 
* **Integrity.** _This plugin is **WYSIWYG only**._ Content that is blocked, is not automatically protecting your integrity. If an application, used by someone, decides to share your personal information to that user (i.e. Facebook asks their users to share friend list etc), this plugin won't block that access.

_(WYSIWYG = What you see is what you get. Basically, the plugin relieves you from disturbing elements)_

### What may be supported in future

As I am using Chrome myself (full time, never switching) the target platform has been Chrome. However, I can see that other browsers may want the same support. Firefox is probably the next project in queue.

### Short history

The prior extension name is "Tornevall Networks NetFilter" and has [a deprecated documentation located here](https://docs.tornevall.net/x/P4Cp).

The primary purpose of this NetFilter was to take control over your news feeds. At the time for the codebase the extension was limited to Facebook and basically has one mission: To remove content based on other user's spammy behaviour. At the time the "application" _**What character are you**_ and many others, was widely popular to spam with. It basically made the newsfeed look ugly.

**Today**, we look beyond only one platform.


## API?

Yes. In the future release, the purpose is to make this extension API based. Initially, the project will run without this (as the API base is not finished anyway). Running without an API could also be an advantage, since we don't have any external dependencies that way. So - there's nothing to maintain uptime for. Neither there's nothing do DDoS.

## So what is the purpose of an API?

To share data in a simpler way and do maintain "bad content" (satire, political spheres etc) from a central place.
